import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.awt.Font;

/**
 * Write a description of class countdown here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Countdown extends Weapon
{
    private Grenade granade;
    private Clustergrenade clustergrenade;
    private Dynamite dynamite;
    private Sheep sheep;
    private Bananabomb bananabomb;
    
    private int actCounter = 0;
    private int timeToExplode = 5;
    
    public Countdown(Grenade g) {
        granade = g;
        timeToExplode = g.getTimeToExplode();
        getImage().clear();
        getImage().scale(15, 20);
        getImage().setColor(Color.red);
        getImage().setFont(new Font("font_15", Font.BOLD, 15));
        getImage().drawString(Integer.toString(timeToExplode), 5, 13);
    }
    
    public Countdown(Clustergrenade c) {
        clustergrenade = c;
        timeToExplode = c.getTimeToExplode();
        getImage().clear();
        getImage().scale(15, 20);
        getImage().setColor(Color.red);
        getImage().setFont(new Font("font_15", Font.BOLD, 15));
        getImage().drawString(Integer.toString(timeToExplode), 5, 13);
    }
    
    public Countdown(Dynamite d) {
        timeToExplode = 5;
        dynamite = d;
        getImage().clear();
        getImage().scale(15, 20);
        getImage().setColor(Color.red);
        getImage().setFont(new Font("font_15", Font.BOLD, 15));
        getImage().drawString(Integer.toString(timeToExplode), 5, 13);
    }
    
    public Countdown(Sheep s) {
        timeToExplode = 5;
        sheep = s;
        getImage().clear();
        getImage().scale(15, 20);
        getImage().setColor(Color.red);
        getImage().setFont(new Font("font_15", Font.BOLD, 15));
        getImage().drawString(Integer.toString(timeToExplode), 5, 13);
    }
    
    public Countdown(Bananabomb b) {
        bananabomb = b;
        timeToExplode = b.getTimeToExplode();
        getImage().clear();
        getImage().scale(15, 20);
        getImage().setColor(Color.red);
        getImage().setFont(new Font("font_15", Font.BOLD, 15));
        getImage().drawString(Integer.toString(timeToExplode), 5, 13);
    }
    
    /**
     * Call the run method to run the game if the game is executed.
     */
    public void act() {
        if (getWorld().getObjects(Break_Menu.class).isEmpty()) {
            run();
        }
    }
    
    public void run() {
        if (granade != null) {
            setLocation(granade.getX(), granade.getY()-25);
            actCounter++;
            if (actCounter >= 100) {
                timeToExplode--;
                actCounter = 0;
                getImage().clear();
                getImage().drawString(Integer.toString(timeToExplode), 5, 13);
            }
            else {
                actCounter++;
            }
            if (timeToExplode == 0) {
                granade.explode();
                getWorld().removeObject(this);
            }
        }
        else if (clustergrenade != null) {
            setLocation(clustergrenade.getX(), clustergrenade.getY()-25);
            actCounter++;
            if (actCounter >= 100) {
                timeToExplode--;
                actCounter = 0;
                getImage().clear();
                getImage().drawString(Integer.toString(timeToExplode), 5, 13);
            }
            else {
                actCounter++;
            }
            if (timeToExplode == 0) {
                clustergrenade.explode();
                getWorld().removeObject(this);
            }
        }
        else if (dynamite != null) {
            setLocation(dynamite.getX(), dynamite.getY()-30);
            actCounter++;
            if (actCounter >= 100) {
                timeToExplode--;
                actCounter = 0;
                getImage().clear();
                getImage().drawString(Integer.toString(timeToExplode), 5, 13);
            }
            else {
                actCounter++;
            }
            if (timeToExplode == 0) {
                dynamite.explode();
                getWorld().removeObject(this);
            }
        }
        else if (sheep != null) {
            setLocation(sheep.getX(), sheep.getY()-30);
            actCounter++;
            if (actCounter >= 100) {
                timeToExplode--;
                actCounter = 0;
                getImage().clear();
                getImage().drawString(Integer.toString(timeToExplode), 5, 13);
            }
            else {
                actCounter++;
            }
            if (timeToExplode == 0) {
                sheep.explode();
            }
        }
        else if (bananabomb != null) {
            setLocation(bananabomb.getX(), bananabomb.getY()-30);
            actCounter++;
            if (actCounter >= 100) {
                timeToExplode--;
                actCounter = 0;
                getImage().clear();
                getImage().drawString(Integer.toString(timeToExplode), 5, 13);
            }
            else {
                actCounter++;
            }
            if (timeToExplode == 0) {
                bananabomb.explode();
                getWorld().removeObject(this);
            }
        }
    }
}
