import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;

/**
 * Write a description of class Help_Display here.
 * 
 * @author (your name)
 * @version (a version number or a date)
 */
public class Help_Display extends Menu
{
    
    public Help_Display() {
        
    }
    
    public Help_Display(int textNumber) {
        displayText(textNumber);
    }
    
    public void act() {
        FullScreenMouseInfo mouse = FullScreenWindow.getMouseInfo();
        if (mouse != null) {
            setLocation(mouse.getX() + getImage().getWidth()/2, mouse.getY() + getImage().getHeight()/2);
        }
    }
    
    public void displayText(int textNumber) {
        Color bgColor = new Color(255, 230, 155, 255);
        switch (textNumber) {
            case 1:
                changeImage(new GreenfootImage(" Bazooka: \n The Bazooka is shot by the aim-display. \n Use the mouse to set the direction and the \n speed of the Bazooka and fire with a \n mouse-click. The Bazooka will explode when it \n hits the ground, anoter worm or an oildrum. ", 16, Color.BLACK, bgColor));
                getImage().setColor(Color.BLACK);
                getImage().drawRect(0, 0, getImage().getWidth()-1, getImage().getHeight()-1);
                break;
            case 2:
                changeImage(new GreenfootImage(" Grenade: \n The Grenade is thrown by the aim-display. \n Use the mouse to set the direction and the \n speed of the Grenade and fire with a \n mouse-click. The Grenade will explode after \n the counter reches null. To set the \n counter use " + Settings.wormSelect + ". ", 16, Color.BLACK, bgColor));
                getImage().setColor(Color.BLACK);
                getImage().drawRect(0, 0, getImage().getWidth()-1, getImage().getHeight()-1);
                break;
            case 3:
                changeImage(new GreenfootImage(" Clustergrenade \n The Clustergrenade is thrown by the \n aim-display. Use the mouse to set the \n direction and the speed of the Clustergrenade \n and fire with a mouse-click. When the \n counter reaches null the Grenade will split \n into parts. Each one of this \n parts explodes when it hits the ground, \n another worm or an oildrum. To set \n the counter use " + Settings.wormSelect + ". ", 16, Color.BLACK, bgColor));
                getImage().setColor(Color.BLACK);
                getImage().drawRect(0, 0, getImage().getWidth()-1, getImage().getHeight()-1);
                break;
            case 4:
                changeImage(new GreenfootImage(" Shotgun: \n To aim with the Shotgun look in the direction \n of the target and aim with the mouse. \n Fire with a mouse-click. You can also \n fire while you are jumping. ", 16, Color.BLACK, bgColor));
                getImage().setColor(Color.BLACK);
                getImage().drawRect(0, 0, getImage().getWidth()-1, getImage().getHeight()-1);
                break;
            case 5:
                changeImage(new GreenfootImage(" Seeking Missile: \n First move to a position from where \n you can shot the missile. Then click on \n the target and use the aim-display to \n fire the missile. Use the mouse to set the \n direction and the speed of the Seeking \n Missile and fire with a mouse-click. \n The missile will first fly in the \n direction of the shot and then change \n the direction to the target. ", 16, Color.BLACK, bgColor));
                getImage().setColor(Color.BLACK);
                getImage().drawRect(0, 0, getImage().getWidth()-1, getImage().getHeight()-1);
                break;
            case 6:
                changeImage(new GreenfootImage(" Dynamite: \n Move to the target worm and throw the \n Dynamite with a mouse-click. The worm will \n throw the Dynamite just in front of him. \n Then you've got 5 seconds to run away. ", 16, Color.BLACK, bgColor));
                getImage().setColor(Color.BLACK);
                getImage().drawRect(0, 0, getImage().getWidth()-1, getImage().getHeight()-1);
                break;
            case 7:
                changeImage(new GreenfootImage(" Sheep: \n Look in the direction you want the Sheep \n to move and throw it with a mouse-click. If you \n want the Sheep to explode click again. \n Otherwhile the Sheep will explode after \n some time. ", 16, Color.BLACK, bgColor));
                getImage().setColor(Color.BLACK);
                getImage().drawRect(0, 0, getImage().getWidth()-1, getImage().getHeight()-1);
                break;
            case 8:
                changeImage(new GreenfootImage(" Baseball Bat: \n Move to the target worm and hit \n him with the Baseball Bat. Hit with a \n mouse-click and watch the other worm \n flying. ", 16, Color.BLACK, bgColor));
                getImage().setColor(Color.BLACK);
                getImage().drawRect(0, 0, getImage().getWidth()-1, getImage().getHeight()-1);
                break;
            case 9:
                changeImage(new GreenfootImage(" Holly Grenade: \n The Holly Grenade is thrown by \n the aim-display. Use the mouse to set the \n direction and the speed of the Holly Grenade, \n fire with a mouse-click and wait for the \n \"Hallelujah\". The Grenade will explode \n after it isn't moving anymore. ", 16, Color.BLACK, bgColor));
                getImage().setColor(Color.BLACK);
                getImage().drawRect(0, 0, getImage().getWidth()-1, getImage().getHeight()-1);
                break;
            case 10:
                changeImage(new GreenfootImage(" Bananabomb: \n The Bananabomb is thrown by the \n aim-display. Use the mouse to set the direction \n and the speed of the Bananabomb and fire \n with a mouse-click. When the counter reaches \n null the Bananabomb will split into parts. \n Each one of this parts explodes \n when it hits the ground, another worm \n or an oildrum. To set the counter use " + Settings.wormSelect + ". ", 16, Color.BLACK, bgColor));
                getImage().setColor(Color.BLACK);
                getImage().drawRect(0, 0, getImage().getWidth()-1, getImage().getHeight()-1);
                break;
            case 11:
                changeImage(new GreenfootImage(" Uzi: \n To aim with the Uzi look in the direction \n of the target and aim with the mouse. Start \n shooting with a mouse-click. You can also \n fire while you are jumping. ", 16, Color.BLACK, bgColor));
                getImage().setColor(Color.BLACK);
                getImage().drawRect(0, 0, getImage().getWidth()-1, getImage().getHeight()-1);
                break;
            case 12:
                changeImage(new GreenfootImage(" Armageddon: \n Use a mouse-click to start the \n Armageddon. And then start praying. ", 16, Color.BLACK, bgColor));
                getImage().setColor(Color.BLACK);
                getImage().drawRect(0, 0, getImage().getWidth()-1, getImage().getHeight()-1);
                break;
            case 13:
                changeImage(new GreenfootImage(" Super Sheep: \n Look in the direction you want the \n Sheep to move and throw it with a mouse-click. \n Use another mouse-click to make the \n sheep start flying. Then the Super Sheep will \n follow your mouse cursor and explode when \n it hits the ground, an oter worm \n or an oildrum. ", 16, Color.BLACK, bgColor));
                getImage().setColor(Color.BLACK);
                getImage().drawRect(0, 0, getImage().getWidth()-1, getImage().getHeight()-1);
                break;
            case 14:
                changeImage(new GreenfootImage(" Airstrike: \n Use the mouse to mark the target of the \n Airstrike and start it with a mouse-click. ", 16, Color.BLACK, bgColor));
                getImage().setColor(Color.BLACK);
                getImage().drawRect(0, 0, getImage().getWidth()-1, getImage().getHeight()-1);
                break;
            case 15:
                changeImage(new GreenfootImage(" Firepunch: \n Move to the target worm and hit him \n with the Firepunch. Hit with a mouse-click \n and watch the other worm flying. ", 16, Color.BLACK, bgColor));
                getImage().setColor(Color.BLACK);
                getImage().drawRect(0, 0, getImage().getWidth()-1, getImage().getHeight()-1);
                break;
            case 16:
                changeImage(new GreenfootImage(" Skipping Rope: \n If you have got no idea for a good \n turn use the Skipping Rope to skip this \n turn. Use it with a mouse-click. ", 16, Color.BLACK, bgColor));
                getImage().setColor(Color.BLACK);
                getImage().drawRect(0, 0, getImage().getWidth()-1, getImage().getHeight()-1);
                break;
            case 17:
                changeImage(new GreenfootImage(" Teleporter: \n If you are staying at a bad position \n use the Teleporter to move everywhere you \n want. Use the mouse-cursor to mark the \n target and start the Teleporter with a \n mouse-click. ", 16, Color.BLACK, bgColor));
                getImage().setColor(Color.BLACK);
                getImage().drawRect(0, 0, getImage().getWidth()-1, getImage().getHeight()-1);
                break;
            case 18:
                changeImage(new GreenfootImage(" Burner: \n If there is a wall between you and the \n other worm burn it down. Look in the direction \n you want to move and start the Burner \n with a mouse-click. The Burner will move to the \n direction of the mouse cursor. You can \n also hurt other worms with the \n Burner. ", 16, Color.BLACK, bgColor));
                getImage().setColor(Color.BLACK);
                getImage().drawRect(0, 0, getImage().getWidth()-1, getImage().getHeight()-1);
                break;
            case 19:
                changeImage(new GreenfootImage(" Magnet: \n Magnets influence metallic weapons or \n objects. The red one attracts and the blue one \n repulses. To change the Magnet-Types use \n " + Settings.wormSelect + ". The Magnet is shot by \n the aim-display. Use the mouse to \n set the direction and the speed \n of the Magnet and fire with a \n mouse-click. ", 16, Color.BLACK, bgColor));
                getImage().setColor(Color.BLACK);
                getImage().drawRect(0, 0, getImage().getWidth()-1, getImage().getHeight()-1);
                break;
            case 20:
                changeImage(new GreenfootImage(" Jetpack: \n With a Jetpack you can fly all over the \n map. Activate and deactivate it with a \n mouse-click. To move use the \n arrow-keys. ", 16, Color.BLACK, bgColor));
                getImage().setColor(Color.BLACK);
                getImage().drawRect(0, 0, getImage().getWidth()-1, getImage().getHeight()-1);
                break;
            case 21:
                changeImage(new GreenfootImage(" Kamikaze: \n If you haven't got any more ammo use \n your worm as ammo. Just click on the target and \n the worm will move there and destroy it. \n A Kamikaze worm kan move through earth. Your \n worm will die while the Kamikaze. ", 16, Color.BLACK, bgColor));
                getImage().setColor(Color.BLACK);
                getImage().drawRect(0, 0, getImage().getWidth()-1, getImage().getHeight()-1);
                break;
            case 22:
                changeImage(new GreenfootImage(" Bunker Buster: \n If the enemy worm is in a cave \n you can get him using a Bunker Buster. Use the \n mouse to mark the target and start it with \n a mouse-click. The Bunker Buster will dig \n through the earth and explode if it hits \n a worm or a oildrum.", 16, Color.BLACK, bgColor));
                getImage().setColor(Color.BLACK);
                getImage().drawRect(0, 0, getImage().getWidth()-1, getImage().getHeight()-1);
                break;
        }
    }
}
