import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.awt.Font;
/**
 * Write a description of class Key_Menu here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Key_Menu extends Menu
{
    private int x;
    private int y;
    
    private int activeTextField = 1;
    private int cursorVisibleCounter = 0;
    
    private String input = "";
    
    private String[] keys = {Settings.wormJump, Settings.wormUp, Settings.wormDown, Settings.wormLeft, Settings.wormRight, Settings.wormChangeWeapon, Settings.wormPause, Settings.wormSelect};
    private String[] defaultKeys = {"space", "up", "down", "left", "right", "enter", "escape", "backspace"};
    
    public Key_Menu() {
        changeImage(new GreenfootImage("Key_Menu.jpg"));
    }
    
    public void act() {
        if (getWorld().getObjects(Break_Menu.class).isEmpty()) {
            run();
        }  
    }
    
     public void run() {
        FullScreenMouseInfo mouse = FullScreenWindow.getMouseInfo();
        if (mouse != null) {
            x = mouse.getX();
            y = mouse.getY();
        }
        if (FullScreenWindow.mouseClicked(null)) {
            if (x > 209 && x < 447 && y > 201 && y < 245) {
                activeTextField = 1;
            }
            if (x > 209 && x < 447 && y > 304 && y < 348) {
                activeTextField = 2;
            }
            if (x > 209 && x < 447 && y > 408 && y < 452) {
                activeTextField = 3;
            }
            if (x > 209 && x < 447 && y > 515 && y < 559) {
                activeTextField = 4;
            }
            if (x > 209 && x < 447 && y > 619 && y < 663) {
                activeTextField = 5;
            }
            if (x > 909 && x < 1147 && y > 205 && y < 250) {
                activeTextField = 6;
            }
            if (x > 909 && x < 1147 && y > 309 && y < 352) {
                activeTextField = 7;
            }
            if (x > 909 && x < 1147 && y > 411 && y < 455) {
                activeTextField = 8;
            }
            if (y > 615 && y < 667) {
                if (x > 578 && x < 827) {
                    //Back;
                    getWorld().removeObject(this); 
                    return;
                } 
                if (x > 861 && x < 1110) {
                    //Finished;
                    if (!keys[0].equals("") && !keys[1].equals("") && !keys[2].equals("") && !keys[3].equals("") && !keys[4].equals("") && !keys[5].equals("") && 
                        !keys[6].equals("") && !keys[7].equals("")) {
                        submitValues();
                        Settings.saveSettings();
                        getWorld().removeObject(this);
                        return;
                    }
                    else {
                        //add dialog menu;
                    }
                }
                //default keys;
                /*if (x >  && x < ) {
                    keys = defaultKeys;
                }*/
            }
        }
        input = FullScreenWindow.getKey();
        if (input != null && input != "") {
            keys[activeTextField-1] = input;
        }
        drawNumbers();
    }
    
    private void submitValues() {
        Settings.wormJump = keys[0];
        Settings.wormUp = keys[1];
        Settings.wormDown = keys[2];
        Settings.wormLeft = keys[3];
        Settings.wormRight = keys[4];
        Settings.wormChangeWeapon = keys[5];
        Settings.wormPause = keys[6];
        Settings.wormSelect = keys[7];
    }
    
    private void drawNumbers() {
        int lineX = 0;
        int lineY = 0;
        GreenfootImage img = new GreenfootImage(keys[activeTextField-1], 35, Color.black, Color.black);
        cursorVisibleCounter++;
        if (cursorVisibleCounter > 80) {
            cursorVisibleCounter = 0;
        }
        switch (activeTextField) {
            case 1:
                lineX = 216;
                lineY = 204;
                break;
            case 2:
                lineX = 216;
                lineY = 307;
                break;
            case 3:
                lineX = 216;
                lineY = 410;
                break;
            case 4:
                lineX = 216;
                lineY = 518;
                break;
            case 5:
                lineX = 216;
                lineY = 622;
                break;
            case 6:
                lineX = 916;
                lineY = 209;
                break;
            case 7:
                lineX = 916;
                lineY = 310;
                break;
            case 8:
                lineX = 916;
                lineY = 413;
                break;    
        }
        getImage().setColor(getImage().getColorAt(210, 204));
        getImage().fillRect(209, 201, 238, 44);
        getImage().fillRect(209, 304, 238, 44);
        getImage().fillRect(209, 408, 238, 44);
        getImage().fillRect(209, 515, 238, 44);
        getImage().fillRect(209, 619, 238, 44);
        getImage().fillRect(909, 205, 238, 44);
        getImage().fillRect(909, 309, 238, 44);
        getImage().fillRect(909, 411, 238, 44);
        getImage().drawImage(new GreenfootImage(keys[0], 35, Color.white, new Color(0, 0, 0, 0)), 216, 204);
        getImage().drawImage(new GreenfootImage(keys[1], 35, Color.white, new Color(0, 0, 0, 0)), 216, 308);
        getImage().drawImage(new GreenfootImage(keys[2], 35, Color.white, new Color(0, 0, 0, 0)), 216, 411);
        getImage().drawImage(new GreenfootImage(keys[3], 35, Color.white, new Color(0, 0, 0, 0)), 216, 518);
        getImage().drawImage(new GreenfootImage(keys[4], 35, Color.white, new Color(0, 0, 0, 0)), 216, 622);
        getImage().drawImage(new GreenfootImage(keys[5], 35, Color.white, new Color(0, 0, 0, 0)), 916, 210);
        getImage().drawImage(new GreenfootImage(keys[6], 35, Color.white, new Color(0, 0, 0, 0)), 916, 310);
        getImage().drawImage(new GreenfootImage(keys[7], 35, Color.white, new Color(0, 0, 0, 0)), 916, 413);
        getImage().setColor(Color.white);
        if (cursorVisibleCounter > 40) {
            getImage().fillRect((int) (lineX + img.getWidth() + 2), lineY + 3, 3, img.getHeight());
        }
    }
}
