import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.awt.Font;

/**
 * Write a description of class Main_Menu here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Main_Menu extends Menu
{
    private int x;
    private int y;
    
    private int map = 0;
    private int textur = 0;
    
    private int numberOfWorms = 2;
    private int numberOfPlayers = 1;
    private int numberOfWormparties = 4;
    private int numberOfWeaponPackage = 0;
    
    public String[] weaponPackage = {"Default", "Bazookas & Grenades", "Projectile Weapons", "Big Bang", "Weapon Test"};
    
    public Main_Menu() {
        changeImage(new GreenfootImage("Main_Menu.jpg"));
    }
    
    public void act() {
        if (getWorld().getObjects(Settings_Menu.class).isEmpty()) {
            run();
        }
    }
    
    public void run() {
        FullScreenMouseInfo mouse = FullScreenWindow.getMouseInfo();
        if (mouse != null) {
            x = mouse.getX();
            y = mouse.getY();
        }
        drawNumbers();
        if (FullScreenWindow.mouseClicked(null)) {
            if (x > 280 && x < 335) {
                if (y > 250 && y < 285) {
                    //Number of Worms "plus";
                    if (numberOfWorms == 4) {
                        numberOfWorms = 1;
                    }
                    else {
                        numberOfWorms ++;
                    }
                    drawNumbers();
                }
                else if (y > 310 && y < 350) {
                    //Number of Worms "minus";
                    if (numberOfWorms == 1) {
                        numberOfWorms = 4;
                    }
                    else {
                        numberOfWorms --;
                    }
                    drawNumbers();  
                }
                else if (y > 515 && y < 550) {
                    //Number of players "plus";
                    if (numberOfPlayers == 4) {
                        numberOfPlayers = 1;
                    }
                    else {
                        numberOfPlayers ++;
                    }
                    if (numberOfPlayers > numberOfWormparties) {
                        numberOfWormparties = numberOfPlayers;
                    }
                    drawNumbers();
                }
                else if (y > 575 && y < 610) {
                    //Number of players "minus";
                    if (numberOfPlayers == 1) {
                        numberOfPlayers = 4;
                    }
                    else {
                        numberOfPlayers --;
                    }
                    if (numberOfPlayers > numberOfWormparties) {
                        numberOfWormparties = numberOfPlayers;
                    }
                    drawNumbers();
                }
            }
            else if (x > 1095 && x < 1150) {
                if (y > 250 && y < 285) {
                    //Number of Wormparties "plus";
                    if (numberOfWormparties == 4) {
                        numberOfWormparties = 2;
                    }
                    else {
                        numberOfWormparties ++;
                    }
                    drawNumbers();
                }
                else if (y > 310 && y < 345) {
                    //Number of Wormparties "minus";
                    if (numberOfWormparties == 2) {
                        numberOfWormparties = 4;
                    }
                    else {
                        numberOfWormparties --;
                    }
                    drawNumbers();
                }
                else if (y > 515 && y < 550) {
                    //Weaponpackage "up";
                    if (numberOfWeaponPackage == (weaponPackage.length-1)) {
                        numberOfWeaponPackage = 0;
                    }
                    else {
                        numberOfWeaponPackage++;
                    }
                    drawNumbers();
                }
                else if (y > 575 && y < 610) {
                    //Weaponpackage "down";
                    if (numberOfWeaponPackage == 0) {
                        numberOfWeaponPackage = weaponPackage.length-1;
                    }
                    else {
                        numberOfWeaponPackage--;
                    }
                    drawNumbers();
                }
            }
            else if (x > 340 && x < 590 && y > 625 && y < 680) {
                //Settings;
                getWorld().addObject(new Settings_Menu(this), 600, 350);
            }
            else if (x > 625 && x < 875 && y > 625 && y < 680) {
                //Finished;
                submitValues();
                ((Worms_Land) getWorld()).startGame();
                try {
                    getWorld().removeObject(this);
                }
                catch (NullPointerException npe) {
                    //npe.printStackTrace();
                }
            }
        }
        //System.out.println(x + " " + y);
    }
    
    public void receiveValues(int[]values) {
        map = values[0];
        textur = values[1];
    }
    
    private void submitValues() {
        String[][] wormNames = new String[4][5];
        boolean[] numberOfPartieNames = new boolean[12];
        int random;
        Settings.resetTeamNames();
        for (int i = 0; i < 12; i++) {
            numberOfPartieNames[i] = true;
        }
        for (int i = 0; i < 4; i++) {
            random = Greenfoot.getRandomNumber(12);
            if (numberOfPartieNames[random]) {
                wormNames[i] = Settings.getTeamNames(random+1);
                numberOfPartieNames[random] = false;
            }
            else {
                i--;
            }
        }
        if (Settings.profile != null) {
            wormNames[0][0] = Settings.profile.getTeamName();
            wormNames[0][1] = Settings.profile.getWormName1();
            wormNames[0][2] = Settings.profile.getWormName2();
            wormNames[0][3] = Settings.profile.getWormName3();
            wormNames[0][4] = Settings.profile.getWormName4();
        }
        for (int i = numberOfWormparties; i < 4; i++) {
            wormNames[i][0] = "";
            wormNames[i][1] = "";
            wormNames[i][2] = "";
            wormNames[i][3] = "";
            wormNames[i][4] = "";
        }
        ((Worms_Land) getWorld()).receiveValues(new int[] {map, textur, numberOfWorms, numberOfPlayers, numberOfWormparties, numberOfWeaponPackage}, wormNames);
    }
    
    private void drawNumbers() {
        //overwrite the old numbers/text;
        getImage().setColor(getImage().getColorAt(50, 50));
        getImage().fillRect(200, 250, 60, 100);
        getImage().fillRect(200, 515, 60, 100);
        getImage().fillRect(1015, 250, 60, 100);
        getImage().fillRect(760, 515, 325, 100);
        //write the new numbers/text;
        getImage().setColor(Color.black);
        getImage().setFont(new Font("", Font.BOLD, 50));
        getImage().drawString(Integer.toString(numberOfWorms), 210, 330);
        getImage().drawString(Integer.toString(numberOfPlayers), 210, 595);
        getImage().drawString(Integer.toString(numberOfWormparties), 1015, 330);
        GreenfootImage weaponPackageImage = new GreenfootImage(weaponPackage[numberOfWeaponPackage], 40, Color.black, new Color(0, 0, 0, 0));
        getImage().drawImage(weaponPackageImage, 1080-weaponPackageImage.getWidth(), 545);
    }
}
