import java.io.FileWriter;
import java.io.FileReader;
import java.io.BufferedWriter;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.FileNotFoundException;

/**
 * Write a description of class Profile here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Profile
{
    private String profileName = "";
    private String teamname = "";
    private String wormName1 = "";
    private String wormName2 = "";
    private String wormName3 = "";
    private String wormName4 = "";
    
    public Profile() {
        
    }
    
    public Profile(String[] values) {
        profileName = values[0];
        teamname = values[1];
        wormName1 = values[2];
        wormName2 = values[3];
        wormName3 = values[4];
        wormName4 = values[5];
    }
    
    public Profile(int index) {
        loadProfile(index);
    }
    
    public void saveProfile() {
        try {
            String fileName;
            BufferedWriter file;
            if (profileExisting() != 0) {
                fileName = "profile" + profileExisting() + ".txt";
                file = new BufferedWriter(new FileWriter(fileName));
            }
            else {
                fileName = "profile" + (getProfileNumber() + 1) + ".txt";
                file = new BufferedWriter(new FileWriter(fileName));
            }
            String[] outputStrings = {profileName, teamname, wormName1, wormName2, wormName3, wormName4};
            for (String output : outputStrings) {
                file.write(output);
                file.write('\n');
            }
            file.close();
        }
        catch (IOException ioe) {
            //ioe.printStackTrace();
        }
    }
    
    private void loadProfile(int index) {
        try {
            BufferedReader file = new BufferedReader(new FileReader("profile" + index + ".txt"));
            String input;
            for (int i = 0; i < 6 && (input = file.readLine()) != null; i++) {
                switch (i) {
                    case 0:
                        profileName = input;
                        break;
                    case 1:
                        teamname = input;
                        break;
                    case 2:
                        wormName1 = input;
                        break;
                    case 3:
                        wormName2 = input;
                        break;
                    case 4:
                        wormName3 = input;
                        break;
                    case 5:
                        wormName4 = input;
                        break;
                }
            }
        }
        catch (FileNotFoundException fnfe) {
            //fnfe.printStackTrace();
        }
        catch (IOException ioe) {
            //ioe.printStackTrace();
        }
    }
    
    public void deleteProfile(int index) {
        if (profileExisting(index)) {
            int numberOfProfiles = getProfileNumber();
            String input;
            String line;
            try {
                String fileName = "profile" + index + ".txt";
                BufferedWriter file = new BufferedWriter(new FileWriter(fileName));
                file.write("");
                file.close();
            }
            catch (IOException ioe) {
                //ioe.printStackTrace();
            }
            for (int i = index + 1; i <= numberOfProfiles+1; i++) {
                input = "";
                line = "";
                try {
                    BufferedReader reader = new BufferedReader(new FileReader("profile" + i + ".txt"));
                    while ((line = reader.readLine()) != null) {
                        input += line;
                        input += '\n';
                    }
                    reader.close();
                }
                catch (FileNotFoundException fnfe) {
                    input = "";
                }
                catch (IOException ioe) {
                    //ioe.printStackTrace();
                }
                try {
                    BufferedWriter writer = new BufferedWriter(new FileWriter("profile" + (i - 1) + ".txt"));
                    writer.write(input);
                    writer.close();
                }
                catch (IOException ioe) {
                    //ioe.printStackTrace();
                }
            }
        }
    }
    
    private boolean profileExisting(int index) {
        BufferedReader file;
        try {
            file = new BufferedReader(new FileReader("profile" + index + ".txt"));
            if (file.readLine() != null) {
                return true;
            }
        }
        catch (FileNotFoundException fnfe) {
            //fnfe.printStackTrace();
            return false;
        }
        catch (IOException ioe) {
            //ioe.printStackTrace();
        }
        return false;
    }
    
    public int profileExisting() {
        int profileNumber = getProfileNumber();
        BufferedReader file;
        for (int i = 1; i <= profileNumber; i++) {
            try {
                file = new BufferedReader(new FileReader("profile" + i + ".txt"));
                String input = file.readLine();
                if (profileName.equals(input)) {
                    return i;
                }
            }
            catch (FileNotFoundException fnfe) {
                //fnfe.printStackTrace();
                return 0;
            }
            catch (IOException ioe) {
                //ioe.printStackTrace();
            }
        }
        return 0;
    }
    
    private int getProfileNumber() {
        int profileNumber;
        for (profileNumber = 1; profileNumber <= 10; profileNumber++) {
            try {
                BufferedReader file = new BufferedReader(new FileReader("profile" + profileNumber + ".txt"));
                if (file.readLine() == null) {
                    return profileNumber-1;
                }
            }
            catch (FileNotFoundException fnfe) {
                //fnfe.printStackTrace();
                return profileNumber-1;
            }
            catch (IOException ioe) {
                //ioe.printStackTrace();
            }
        }
        return 10;
    }
    
    public void setProfileName(String profileName) {
        this.profileName = profileName;
    }
    public String getProfileName() {
        return profileName;
    }
    
    public void setTeamName(String teamName) {
        this.teamname = teamname;
    }
    public String getTeamName() {
        return teamname;
    }
    
    public void setWormName1(String wormName1) {
        this.wormName1 = wormName1;
    }
    public String getWormName1() {
        return wormName1;
    }
    
    public void setWormName2(String wormName2) {
        this.wormName2 = wormName2;
    }
    public String getWormName2() {
        return wormName2;
    }
    
    public void setWormName3(String wormName3) {
        this.wormName3 = wormName3;
    }
    public String getWormName3() {
        return wormName3;
    }
    
    public void setWormName4(String wormName4) {
        this.wormName4 = wormName4;
    }
    public String getWormName4() {
        return wormName4;
    }
}