import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)import java.io.FileWriter;
import java.io.FileWriter;
import java.io.FileReader;
import java.io.BufferedWriter;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.FileNotFoundException;

/**
 * Write a description of class Settings here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public abstract class Settings extends Actor
{
    public static int wormLife = 100;
    public static int gravity;
    public static int playerNumber = 3;//number of players per party;
    public static int partys = 2;//number of different partys;
    public static int maximumMines = 5;//maximal number of mines;
    public static int mineExplodingTime = 4;//4 = random;
    public static int players = 1;//number of the human players;
    
    public static int musicVolume = 100;
    public static int effectVolume = 100;
    
    public static boolean partyOneHumanPlayer = true;
    public static boolean partyTwoHumanPlayer = false;
    public static boolean partyThreeHumanPlayer = false;
    public static boolean partyFourHumanPlayer = false;
    
    public static String wormUp = "up";
    public static String wormDown = "down";
    public static String wormLeft = "left";
    public static String wormRight = "right";
    public static String wormJump = "space";
    public static String wormSelect = "backspace";
    public static String wormChangeWeapon = "enter";
    public static String wormPause = "escape";
    public static String worldUp = "w";
    public static String worldDown = "s";
    public static String worldLeft = "a";
    public static String worldRight = "d";
    
    public static String languagePack_1 = "Sprachsatz_Verrückter_Veteran.wav";
    public static String languagePack_2 = "Sprachsatz_Verrückter_Veteran2.wav";
    public static String languagePack_3 = "Sprachsatz_Geheimoperation.wav";
    public static String languagePack_4 = "Sprachsatz_Guantanamo.wav";
    public static String languagePack_5 = "Sprachsatz_Agent.wav";
    public static String languagePack_6 = "Sprachsatz_Geheimagent.wav";
    public static String languagePack_7 = "Sprachsatz_Marieneinfanterist.wav";
    
    //Teamnames
    public static String[] team1 = {"Dark Side", "Darth Sidius", "Darth Vader", "Count Docu", "Darth Maul"};
    public static String[] team2 = {"Insane Killers", "Rambo", "Jon McClane", "Master Chief", "Chef Chellios"};
    public static String[] team3 = {"Southpark", "Kenny", "Cartman", "Stan", "Kyle"};
    public static String[] team4 = {"Nightmear", "Freddy", "Jigsaw", "Jason", "Exorcist"};
    public static String[] team5 = {"Simpsons", "Homer", "Bart", "Maggy", "Lisa"};
    public static String[] team6 = {"A-Team", "Hannibal", "BA", "Murdock", "Face"};
    public static String[] team7 = {"MIB", "Agent J", "Agent K", "Agent Z", "Agent F"};
    public static String[] team8 = {"Muppets", "Kermit", "Animal", "Gonzo", "Ms. Piggy"};
    public static String[] team9 = {"Disney", "Mickey Mouse", "Donald Duck", "Goofy", "Pluto"};
    public static String[] team10 = {"Enterprise", "Captain Kirk", "Mr. Spock", "Dr. McCoy", "Scott"};
    public static String[] team11 = {"Top-Gun", "Maverick", "Goose", "Iceman", "Viper"};
    public static String[] team12 = {"Stones", "Jagger", "Richards", "Wood", "Watts"};
    
    public static Profile profile;
    
    //Bazooka: (Inf | 0), Grenade: (Inf | 0), Clustergrenade: (Inf | 0), Shotgun: (5 | 0), Seeking_Missile: (2 | 2), Dynamite: (1 | 0), Sheep: (1 | 3), Baseball_Bat: (5 | 0), Holly_Grenade: (1 | 5), Bananabomb: (1 | 5);
    private static int[][] default_PackageWeapons = {{11, 0}, {11, 0}, {11, 0}, {5, 0}, {2, 2}, {1, 0}, {1, 3}, {5, 0}, {1, 5}, {1, 5}};
    public static final Weapon_Package defaultPackage = new Weapon_Package(default_PackageWeapons);
    
    //Bazooka: (Inf | 0), Grenade: (Inf | 0), Clustergrenade: (Inf | 0), Shotgun: (0 | 0), Seeking_Missile: (3 | 2), Dynamite: (0 | 0), Sheep: (0 | 0), Baseball_Bat: (0 | 0), Holly_Grenade: (1 | 5), Bananabomb: (1 | 5);
    private static int[][] bazookasAndGrenades_PackageWeapons = {{11, 0}, {11, 0}, {11, 0}, {0, 0}, {3, 2}, {0, 0}, {0, 0}, {0, 0}, {1, 5}, {1, 5}};
    public static final Weapon_Package bazookasAndGrenadesPackage = new Weapon_Package(bazookasAndGrenades_PackageWeapons);
    
    //Bazooka: (Inf | 0), Grenade: (0 | 0), Clustergrenade: (0 | 0), Shotgun: (Inf | 0), Seeking_Missile: (Inf | 0), Dynamite: (1 | 3), Sheep: (0 | 0), Baseball_Bat: (3 | 2), Holly_Grenade: (0 | 0), Bananabomb: (0 | 0);
    private static int[][] projectile_PackageWeapons = {{11, 0}, {0, 0}, {0, 0}, {11, 0}, {11, 0}, {1, 3}, {0, 0}, {3, 2}, {0, 0}, {0, 0}};
    public static final Weapon_Package projectilePackage = new Weapon_Package(projectile_PackageWeapons);
    
    //Bazooka: (Inf | 0), Grenade: (Inf | 0), Clustergrenade: (0 | 0), Shotgun: (0 | 0), Seeking_Missile: (0 | 0), Dynamite: (5 | 0), Sheep: (5 | 0), Baseball_Bat: (0 | 0), Holly_Grenade: (Inf | 0), Bananabomb: (Inf | 0);
    private static int[][] bigBang_PackageWeapons = {{11, 0}, {11, 0}, {0, 0}, {0, 0}, {0, 0}, {5, 0}, {5, 0}, {0, 0}, {11, 0}, {11, 0}};
    public static final Weapon_Package bigBangPackage = new Weapon_Package(bigBang_PackageWeapons);
    
    //Bazooka: (Inf | 0), Grenade: (Inf | 0), Clustergrenade: (Inf | 0), Shotgun: (Inf | 0), Seeking_Missile: (Inf | 0), Dynamite: (Inf | 0), Sheep: (Inf | 0), Baseball_Bat: (Inf | 0), Holly_Grenade: (Inf | 0), Bananabomb: (Inf | 0);
    private static int[][] weaponTest_PackageWeapons = {{11, 0}, {11, 0}, {11, 0}, {11, 0}, {11, 0}, {11, 0}, {11, 0}, {11, 0}, {11, 0}, {11, 0}};
    public static final Weapon_Package weaponTestPackage = new Weapon_Package(weaponTest_PackageWeapons);
    
    //Bazooka: ( | ), Grenade: ( | ), Clustergrenade: ( | ), Shotgun: ( | ), Seeking_Missile: ( | ), Dynamite: ( | ), Sheep: ( | ), Baseball_Bat: ( | ), Holly_Grenade: ( | ), Bananabomb: ( | );
    //private static int[][] PackageWeapons = {{, }, {, }, {, }, {, }, {, }, {, }, {, }, {, }, {, }, {, }};
    //public static final Weapon_Package Package = new Weapon_Package(PackageWeapons);
    
    public static void saveSettings() {
        if (!GreenfootToolkit.getToolkit().playingOnline()) {
            try {
                BufferedWriter file = new BufferedWriter(new FileWriter("settings.txt"));
                String fileName;
                String[] outputStrings = {wormUp, wormDown, wormLeft, wormRight, wormJump, wormSelect, wormChangeWeapon, wormPause, worldUp, worldDown, worldLeft, worldRight, 
                    Integer.toString(musicVolume), Integer.toString(effectVolume)};
                for (String output : outputStrings) {
                    file.write(output);
                    file.write('\n');
                }
                file.close();
            }
            catch (IOException ioe) {
                //ioe.printStackTrace();
            }
        }
    }
    
    public static void loadSettings() {
        if (!GreenfootToolkit.getToolkit().playingOnline()) {
            try {
                BufferedReader file = new BufferedReader(new FileReader("settings.txt"));
                String input;
                for (int i = 0; i < 14 && (input = file.readLine()) != null; i++) {
                    switch (i) {
                        case 0:
                            wormUp = input;
                            break;
                        case 1:
                            wormDown = input;
                            break;
                        case 2:
                            wormLeft = input;
                            break;
                        case 3:
                            wormRight = input;
                            break;
                        case 4:
                            wormJump = input;
                            break;
                        case 5:
                            wormSelect = input;
                            break;
                        case 6:
                            wormChangeWeapon = input;
                            break;
                        case 7:
                            wormPause = input;
                            break;
                        case 8:
                            worldUp = input;
                            break;
                        case 9:
                            worldDown = input;
                            break;
                        case 10:
                            worldLeft = input;
                            break;
                        case 11:
                            worldRight  = input;
                            break;
                        case 12:
                            musicVolume = Integer.parseInt(input);
                            break;
                        case 13:
                            effectVolume = Integer.parseInt(input);
                            break;
                    }
                }
            }
            catch (FileNotFoundException fnfe) {
                //fnfe.printStackTrace();
                useDefaultSettings();
            }
            catch (IOException ioe) {
                //ioe.printStackTrace();
            }
            catch (NumberFormatException nfe) {
                nfe.printStackTrace();
            }
        }
        else {
            useDefaultSettings();
        }
    }
    
    private static void useDefaultSettings() {
        wormUp = "up";
        wormDown = "down";
        wormLeft = "left";
        wormRight = "right";
        wormJump = "space";
        wormSelect = "backspace";
        wormChangeWeapon = "enter";
        wormPause = "escape";
        worldUp = "w";
        worldDown = "s";
        worldLeft = "a";
        worldRight = "d";
        musicVolume = 100;
        effectVolume = 100;
    }
    
    public static void resetTeamNames() {
        team1 = new String[]{"Dark Side", "Darth Sidius", "Darth Vader", "Count Docu", "Darth Maul"};
        team2 = new String[]{"Insane Killers", "Rambo", "Jon McClane", "Master Chief", "Chef Chellios"};
        team3 = new String[]{"Southpark", "Kenny", "Cartman", "Stan", "Kyle"};
        team4 = new String[]{"Nightmear", "Freddy", "Jigsaw", "Jason", "Exorcist"};
        team5 = new String[]{"Simpsons", "Homer", "Bart", "Maggy", "Lisa"};
        team6 = new String[]{"A-Team", "Hannibal", "BA", "Murdock", "Face"};
        team7 = new String[]{"MIB", "Agent J", "Agent K", "Agent Z", "Agent F"};
        team8 = new String[]{"Muppets", "Kermit", "Animal", "Gonzo", "Ms. Piggy"};
        team9 = new String[]{"Disney", "Mickey Mouse", "Donald Duck", "Goofy", "Pluto"};
        team10 = new String[]{"Enterprise", "Captain Kirk", "Mr. Spock", "Dr. McCoy", "Scott"};
        team11 = new String[]{"Top-Gun", "Maverick", "Goose", "Iceman", "Viper"};
        team12 = new String[]{"Stones", "Jagger", "Richards", "Wood", "Watts"};
    }
    
    public static String getSoundByNumber(int languagePack) {
        switch (languagePack) {
            case 1:
                return languagePack_1;
            case 2:
                return languagePack_2;
            case 3:
                return languagePack_3;
            case 4:
                return languagePack_4;
            case 5:
                return languagePack_5;
            case 6:
                return languagePack_6;
            case 7:
                return languagePack_7;
            default:
                return languagePack_1;
        }
    }
    
    public static Weapon_Package getWeaponPackageByNumber(int weaponPackage) {
        switch (weaponPackage) {
            case 1:
                return defaultPackage;
            case 2:
                return bazookasAndGrenadesPackage;
            case 3:
                return projectilePackage;
            case 4:
                return bigBangPackage;
            case 5:
                return weaponTestPackage;
            default:
                System.out.println("Settings: Unknown Weapon_Package requested");
                return defaultPackage;
        }
    }
    
    public static String[] getTeamNames(int number) {
        switch (number) {
            case 1:
                return team1;
            case 2:
                return team2;
            case 3:
                return team3;
            case 4:
                return team4;
            case 5:
                return team5;
            case 6:
                return team6;
            case 7:
                return team7;
            case 8:
                return team8;
            case 9:
                return team9;
            case 10:
                return team10;
            case 11:
                return team11;
            case 12:
                return team12;
            default:
                System.out.println("Settings: Team Unknown");
                return new String[5];
        }
    }
}