import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;

/**
 * Write a description of class Texturs here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Texturs extends Actor
{
    private GreenfootImage basicImage;
    private GreenfootImage backgroundImage;
    private GreenfootImage water;
    
    private final Color transparent = new Color(0, 0, 0, 0);
    
    private int suddenDeathHeight = 0;
    
    public Texturs(int textur) {
        suddenDeathHeight = 0;
        getImage().clear();
        getImage().scale(1200, 700);
        switch (textur) {//the different texturpacks;
            case 1:
                basicImage = new GreenfootImage("Textur_1.jpg");
                backgroundImage = new GreenfootImage(1200, 700);
                backgroundImage.setColor(new Color(0, 150, 255, 125));
                backgroundImage.fill();
                water = new GreenfootImage("Water.jpg");
                break;
            case 2:
                basicImage = new GreenfootImage("Textur_2.jpg");
                backgroundImage = new GreenfootImage(1200, 700);
                backgroundImage.setColor(new Color(30, 70, 255, 255));
                backgroundImage.fill();
                water = new GreenfootImage("Water.jpg");
                break;
            case 3:
                basicImage = new GreenfootImage("Textur_3.jpg");
                backgroundImage = new GreenfootImage(1200, 700);
                backgroundImage.setColor(new Color(30, 70, 255, 70));
                backgroundImage.fill();
                water = new GreenfootImage("Water.jpg");
                break;
            case 4:
                basicImage = new GreenfootImage("Textur_4.jpg");
                backgroundImage = new GreenfootImage(1200, 700);
                backgroundImage.setColor(new Color(160, 120, 50, 255));
                backgroundImage.fill();
                water = new GreenfootImage("Water.jpg");
                break;
            case 5:
                basicImage = new GreenfootImage("Textur_5.jpg");
                backgroundImage = new GreenfootImage(1200, 700);
                backgroundImage.setColor(new Color(60, 120, 50, 255));
                backgroundImage.fill();
                water = new GreenfootImage("Water.jpg");
                break;
            case 6:
                basicImage = new GreenfootImage("Textur_6.jpg");
                backgroundImage = new GreenfootImage(1200, 700);
                backgroundImage.setColor(new Color(0, 150, 255, 125));
                backgroundImage.fill();
                water = new GreenfootImage("Water.jpg");
                break;
            default:
                basicImage = new GreenfootImage("Textur_1.jpg");
                backgroundImage = new GreenfootImage(1200, 700);
                backgroundImage.setColor(new Color(0, 150, 255, 125));
                backgroundImage.fill();
                water = new GreenfootImage("Water.jpg");
                break;
        }
    }
    
    public void act() {
        if (((Worms_Land) getWorld()).getSuddenDeath() && suddenDeathHeight < ((Worms_Land) getWorld()).getSuddenDeathHeight()) {
            suddenDeathHeight += 1;
            drawWater();
        }
    }
    
    public void initialiseBasikImage() {
        for (int x = 0; x < 1200; x++) {
            for (int y = 0; y < 700; y++) {
                if (((Worms_Land) getWorld()).getColorAt(x, y).getBlue() > 25) {
                    basicImage.setColorAt(x, y, transparent);
                }
            }
        }
    }
    
    public void destroyTextur(int x, int y, int radius) {
        basicImage.setColor(Color.white);
        basicImage.fillOval(x - radius, y - radius, radius*2, radius*2);
        for (int i = 0; i < radius*2; i++) {
            for (int j = 0; j < radius*2; j++) {
                if (x - radius + i < basicImage.getWidth() && y - radius + j < basicImage.getHeight() && x - radius + i >= 0 && y - radius + j >= 0) {
                    if (basicImage.getColorAt(x - radius + i, y - radius + j).equals(Color.white)) {
                        basicImage.setColorAt(x - radius + i, y - radius + j, transparent);
                    }
                }
            }
        }
    }
    
    public void redraw() {
        getImage().clear();
        getImage().drawImage(backgroundImage, 0, 0);
        getImage().drawImage(basicImage, 0, 0);
        drawWater();
    }
    private void drawWater() {
        getImage().setColor(Color.blue);
        getImage().fillRect(0, 645 - suddenDeathHeight, 1200, 55 + suddenDeathHeight);
    }
}
