import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Uzi here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Uzi extends Weapon
{
    private int counter = 0;
    
    private boolean shoot = false;
    private boolean imageLeft = false;
    
    private Worm worm;
    
    public Uzi(Worm worm) {
        this.worm = worm;
        scaleImage(getImage(), 40);
    }
    
    /**
     * Call the run method to run the game if the game is executed.
     */
    public void act() {
        if (getWorld().getObjects(Break_Menu.class).isEmpty()) {
            run();
        }
    }
    
    public void run() {
        FullScreenMouseInfo mouse = FullScreenWindow.getMouseInfo();
        if (shoot) {
            if (counter < 130) {
                if (counter % 5 == 0) {
                    if (mouseInRange()) {
                        addBullet(mouse.getX(), mouse.getY());
                    }
                    else {
                        addBullet(getRotation());
                    }
                }
                counter++;
            }
            else {
                //set some variables;
                getWorld().removeObject(this);
                return;
            }
        }
        else if (FullScreenWindow.mouseClicked(null)) {
            if (!shoot) {
                shoot = true;
            }
        }
        if (mouse != null && !worm.getArtificialIntelligence()) {
            if (worm.getImageLeft()) {
                if (!imageLeft) {
                    getImage().mirrorHorizontally();
                    imageLeft = true;
                }
                if (directionToTurnTo(mouse.getX(), mouse.getY()) > 105 && directionToTurnTo(mouse.getX(), mouse.getY()) < 255) {
                    turnTo(mouse.getX(), mouse.getY());
                    turn(180);
                }
                setLocation(worm.getX()-15, worm.getY()+5);
            }
            else {
                if (imageLeft) {
                    getImage().mirrorHorizontally();
                    imageLeft = false;
                }
                if (directionToTurnTo(mouse.getX(), mouse.getY()) > 285 || directionToTurnTo(mouse.getX(), mouse.getY()) < 75) {
                    turnTo(mouse.getX(), mouse.getY());
                }
                setLocation(worm.getX()+15, worm.getY()+5);
            }
        }
    }
    
    public boolean mouseInRange() {
        FullScreenMouseInfo mouse = FullScreenWindow.getMouseInfo();
        if (worm.getImageLeft()) {
            if (directionToTurnTo(mouse.getX(), mouse.getY()) > 105 && directionToTurnTo(mouse.getX(), mouse.getY()) < 255) {
                return true;
            }
        }
        else {
            if (directionToTurnTo(mouse.getX(), mouse.getY()) > 285 || directionToTurnTo(mouse.getX(), mouse.getY()) < 75) {
                return true;
            }
        }
        return false;
    }
    
    public void addBullet(int x, int y) {
        Greenfoot.playSound("uzifire.wav");
        double angle = Math.atan2((y - getY()), (x - getX()));
        angle += Math.toRadians((Math.random()*5)-2.5);
        double vx = getVelX(angle, 0.1);
        double vy = getVelY(angle, 0.1);
        getWorld().addObject(new Bullet(worm, this, vx, vy), getX(), getY());
    }
    public void addBullet(double angle) {
        Greenfoot.playSound("uzifire.wav");
        angle += Math.toRadians((Math.random()*5)-2.5);
        double vx = getVelX(angle, 0.1);
        double vy = getVelY(angle, 0.1);
        getWorld().addObject(new Bullet(worm, this, vx, vy), getX(), getY());
    }
}
