import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.awt.Font;

/**
 * Write a description of class Weapon_Menu here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Weapon_Menu extends Menu
{
    private int x;
    private int y;
    
    private Worm callingWorm;
    
    public Weapon_Menu() {
        changeImage(new GreenfootImage("Weapon_Menu.png"));
        callingWorm = null;
    }
    
    public Weapon_Menu(Worm callingWorm) {
        changeImage(new GreenfootImage("Weapon_Menu.png"));
        this.callingWorm = callingWorm;
    }
    
    /**
     * Call the run method to run the game if the game is executed.
     */
    public void act() {
        if (getWorld().getObjects(Break_Menu.class).isEmpty()) {
            run();
        }
    }
    
    public void run() {
        FullScreenMouseInfo mouse = FullScreenWindow.getMouseInfo();
        if (mouse != null) {
            x = mouse.getX();
            y = mouse.getY();
        }
        drawNumbers();
        if (FullScreenWindow.mouseClicked(null)) {
            if (y > 130 && y < 225) {
                if (x > 210 && x < 310) {
                    //Bazooka;
                    if (callingWorm != null && ((Worms_Land) getWorld()).getWeaponPackage().getWeaponNumber(callingWorm.getParty(), 1) > 0 && ((Worms_Land) getWorld()).getWeaponPackage().getWeaponDelay(callingWorm.getParty(), 1) == 0) {
                        callingWorm.setWeaponUsing(1);
                        callingWorm.getTacticalDisplay().setTextChanged(true);
                        callingWorm.setMissileTarget(false);
                    }
                    getWorld().removeObject(this);
                }
                else if (x > 420 && x < 520) {
                    //Grenade;
                    if (callingWorm != null && ((Worms_Land) getWorld()).getWeaponPackage().getWeaponNumber(callingWorm.getParty(), 2) > 0 && ((Worms_Land) getWorld()).getWeaponPackage().getWeaponDelay(callingWorm.getParty(), 2) == 0) {
                        callingWorm.setWeaponUsing(2);
                        callingWorm.getTacticalDisplay().setTextChanged(true);
                        callingWorm.setMissileTarget(false);
                    }
                    getWorld().removeObject(this);
                }
                else if (x > 635 && x < 735) {
                    //Clustergrenade;
                    if (callingWorm != null && ((Worms_Land) getWorld()).getWeaponPackage().getWeaponNumber(callingWorm.getParty(), 3) > 0 && ((Worms_Land) getWorld()).getWeaponPackage().getWeaponDelay(callingWorm.getParty(), 3) == 0) {
                        callingWorm.setWeaponUsing(3);
                        callingWorm.getTacticalDisplay().setTextChanged(true);
                        callingWorm.setMissileTarget(false);
                    }
                    getWorld().removeObject(this);
                }
                else if (x > 855 && x < 955) {
                    //Shotgun;
                    if (callingWorm != null && ((Worms_Land) getWorld()).getWeaponPackage().getWeaponNumber(callingWorm.getParty(), 4) > 0 && ((Worms_Land) getWorld()).getWeaponPackage().getWeaponDelay(callingWorm.getParty(), 4) == 0) {
                        callingWorm.setWeaponUsing(4);
                        callingWorm.getTacticalDisplay().setTextChanged(true);
                        callingWorm.setMissileTarget(false);
                        getWorld().removeObject(callingWorm.getAimDisplay());
                        if (getWorld().getObjects(Shotgun.class).isEmpty()) {
                            if (callingWorm.getImageLeft()) {
                                getWorld().addObject(callingWorm.getShotgun(), callingWorm.getX()-15, callingWorm.getY()+5);
                            }
                            else {
                                getWorld().addObject(callingWorm.getShotgun(), callingWorm.getX()+15, callingWorm.getY()+5);
                            }
                        }
                    }
                    getWorld().removeObject(this);
                }
            }
            else if (y > 305 && y < 395) {
                if (x > 210 && x < 310) {
                    //Seeking_Missile;
                    if (callingWorm != null && ((Worms_Land) getWorld()).getWeaponPackage().getWeaponNumber(callingWorm.getParty(), 5) > 0 && ((Worms_Land) getWorld()).getWeaponPackage().getWeaponDelay(callingWorm.getParty(), 5) == 0) {
                        callingWorm.setWeaponUsing(5);
                        callingWorm.getTacticalDisplay().setTextChanged(true);
                        callingWorm.setMissileTarget(false);
                        getWorld().removeObject(callingWorm.getAimDisplay());
                    }
                    getWorld().removeObject(this);
                }
                else if (x > 420 && x < 520) {
                    //Dynamite;
                    if (callingWorm != null && ((Worms_Land) getWorld()).getWeaponPackage().getWeaponNumber(callingWorm.getParty(), 6) > 0 && ((Worms_Land) getWorld()).getWeaponPackage().getWeaponDelay(callingWorm.getParty(), 6) == 0) {
                        callingWorm.setWeaponUsing(6);
                        callingWorm.getTacticalDisplay().setTextChanged(true);
                        callingWorm.setMissileTarget(false);
                        getWorld().removeObject(callingWorm.getAimDisplay());
                    }
                    getWorld().removeObject(this);
                }
                else if (x > 635 && x < 735) {
                    //Sheep;
                    if (callingWorm != null && ((Worms_Land) getWorld()).getWeaponPackage().getWeaponNumber(callingWorm.getParty(), 7) > 0 && ((Worms_Land) getWorld()).getWeaponPackage().getWeaponDelay(callingWorm.getParty(), 7) == 0) {
                        callingWorm.setWeaponUsing(7);
                        callingWorm.getTacticalDisplay().setTextChanged(true);
                        callingWorm.setMissileTarget(false);
                        getWorld().removeObject(callingWorm.getAimDisplay());
                    }
                    getWorld().removeObject(this);
                }
                else if (x > 855 && x < 955) {
                    //Baseball_Bat;
                    if (callingWorm != null && ((Worms_Land) getWorld()).getWeaponPackage().getWeaponNumber(callingWorm.getParty(), 8) > 0 && ((Worms_Land) getWorld()).getWeaponPackage().getWeaponDelay(callingWorm.getParty(), 8) == 0) {
                        callingWorm.setWeaponUsing(8);
                        callingWorm.getTacticalDisplay().setTextChanged(true);
                        callingWorm.setMissileTarget(false);
                        getWorld().removeObject(callingWorm.getAimDisplay());
                        if (getWorld().getObjects(Baseball_Bat.class).isEmpty()) {
                            if (callingWorm.getImageLeft()) {
                                getWorld().addObject(callingWorm.getBaseballBat(), callingWorm.getX()-15, callingWorm.getY()+15);
                            }
                            else {
                                getWorld().addObject(callingWorm.getBaseballBat(), callingWorm.getX()+15, callingWorm.getY()+15);
                            }
                        }
                    }
                    getWorld().removeObject(this);
                }
            }
            else if (y > 465 && y < 560) {
                if (x > 210 && x < 310) {
                    //Holly_Grenade;
                    if (callingWorm != null && ((Worms_Land) getWorld()).getWeaponPackage().getWeaponNumber(callingWorm.getParty(), 9) > 0 && ((Worms_Land) getWorld()).getWeaponPackage().getWeaponDelay(callingWorm.getParty(), 9) == 0) {
                        callingWorm.setWeaponUsing(9);
                        callingWorm.getTacticalDisplay().setTextChanged(true);
                        callingWorm.setMissileTarget(false);
                    }
                    getWorld().removeObject(this);
                }
                else if (x > 420 && x < 520) {
                    //Bananabomb;
                    if (callingWorm != null && ((Worms_Land) getWorld()).getWeaponPackage().getWeaponNumber(callingWorm.getParty(), 10) > 0 && ((Worms_Land) getWorld()).getWeaponPackage().getWeaponDelay(callingWorm.getParty(), 10) == 0) {
                        callingWorm.setWeaponUsing(10);
                        callingWorm.getTacticalDisplay().setTextChanged(true);
                        callingWorm.setMissileTarget(false);
                    }
                    getWorld().removeObject(this);
                }
            }
        }
        //System.out.println(x + " " + y);
    }
    
    public void drawNumbers() {
        //overwrite the old numbers;
        getImage().setColor(getImage().getColorAt(50, 50));
        getImage().fillRect(48, 206, 60, 60);
        getImage().fillRect(121, 206, 60, 60);
        getImage().fillRect(263, 206, 60, 60);
        getImage().fillRect(336, 206, 60, 60);
        getImage().fillRect(476, 206, 60, 60);
        getImage().fillRect(549, 206, 60, 60);
        getImage().fillRect(691, 206, 60, 60);
        getImage().fillRect(764, 206, 60, 60);
        getImage().fillRect(48, 372, 60, 60);
        getImage().fillRect(121, 372, 60, 60);
        getImage().fillRect(263, 372, 60, 60);
        getImage().fillRect(336, 372, 60, 60);
        getImage().fillRect(476, 372, 60, 60);
        getImage().fillRect(549, 372, 60, 60);
        getImage().fillRect(691, 372, 60, 60);
        getImage().fillRect(764, 372, 60, 60);
        getImage().fillRect(48, 535, 60, 60);
        getImage().fillRect(121, 535, 60, 60);
        getImage().fillRect(263, 535, 60, 60);
        getImage().fillRect(336, 535, 60, 60);
        //write the new numbers;
        getImage().setFont(new Font("", Font.BOLD, 30));
        String infinity = Character.toString((char) 8734);//"∞";
        Weapon_Package weaponPackage = ((Worms_Land) getWorld()).getWeaponPackage();
        int executingParty = ((Worms_Land) getWorld()).getExecutingParty();
        if (weaponPackage != null && executingParty != 0) {
            String temp;
            int[][] coordinates1 = {{63, 246}, {278, 246}, {491, 246}, {706, 246}, {63, 412}, {278, 412}, {491, 412}, {706, 412}, {63, 575}, {278, 575}};
            int[][] coordinates2 = {{135, 246}, {350, 246}, {564, 246}, {779, 246}, {135, 412}, {350, 412}, {564, 412}, {779, 412}, {135, 575}, {350, 575}};
            for (int i = 0; i < 10; i++) {
                getImage().setColor(Color.red);
                temp = (weaponPackage.getWeaponNumber(executingParty, i+1) == 11 ? infinity : Integer.toString(weaponPackage.getWeaponNumber(executingParty, i+1)));
                getImage().drawString((temp.length() == 1 && !temp.equals(infinity) ? " " + temp : temp), coordinates1[i][0], coordinates1[i][1]);
                getImage().setColor(new Color(255, 75, 0, 255));
                temp = Integer.toString(weaponPackage.getWeaponDelay(executingParty, i+1));
                getImage().drawString((temp.length() == 1 ? " " + temp : temp), coordinates2[i][0], coordinates2[i][1]);
            }
            /*getImage().drawString((weaponPackage.getWeaponNumber(executingParty, 1) == 11 ? infinity : Integer.toString(weaponPackage.getWeaponNumber(executingParty, 1))), 70, 246);
            getImage().drawString(Integer.toString(weaponPackage.getWeaponDelay(executingParty, 1)), 143, 246);*/
        }
        /*else if (executingParty == 0) {//just to test the coordinates;
            
            
            temp = (weaponPackage.getWeaponNumber(1, 2) == 11 ? infinity : Integer.toString(weaponPackage.getWeaponNumber(1, 2)));
            getImage().drawString((temp.length() == 1 && !temp.equals(infinity) ? " " + temp : temp), 278, 246);
            temp = Integer.toString(weaponPackage.getWeaponDelay(1, 2));
            getImage().drawString((temp.length() == 1 ? " " + temp : temp), 350, 246);
            
            temp = (weaponPackage.getWeaponNumber(1, 3) == 11 ? infinity : Integer.toString(weaponPackage.getWeaponNumber(1, 3)));
            getImage().drawString((temp.length() == 1 && !temp.equals(infinity) ? " " + temp : temp), 491, 246);
            temp = Integer.toString(weaponPackage.getWeaponDelay(1, 3));
            getImage().drawString((temp.length() == 1 ? " " + temp : temp), 564, 246);
            
            temp = (weaponPackage.getWeaponNumber(1, 4) == 11 ? infinity : Integer.toString(weaponPackage.getWeaponNumber(1, 4)));
            getImage().drawString((temp.length() == 1 && !temp.equals(infinity) ? " " + temp : temp), 706, 246);
            temp = Integer.toString(weaponPackage.getWeaponDelay(1, 4));
            getImage().drawString((temp.length() == 1 ? " " + temp : temp), 779, 246);
            
            temp = (weaponPackage.getWeaponNumber(1, 5) == 11 ? infinity : Integer.toString(weaponPackage.getWeaponNumber(1, 5)));
            getImage().drawString((temp.length() == 1 && !temp.equals(infinity) ? " " + temp : temp), 63, 412);
            temp = Integer.toString(weaponPackage.getWeaponDelay(1, 5));
            getImage().drawString((temp.length() == 1 ? " " + temp : temp), 135, 412);
            
            temp = (weaponPackage.getWeaponNumber(1, 6) == 11 ? infinity : Integer.toString(weaponPackage.getWeaponNumber(1, 6)));
            getImage().drawString((temp.length() == 1 && !temp.equals(infinity) ? " " + temp : temp), 278, 412);
            temp = Integer.toString(weaponPackage.getWeaponDelay(1, 6));
            getImage().drawString((temp.length() == 1 ? " " + temp : temp), 350, 412);
            
            temp = (weaponPackage.getWeaponNumber(1, 7) == 11 ? infinity : Integer.toString(weaponPackage.getWeaponNumber(1, 7)));
            getImage().drawString((temp.length() == 1 && !temp.equals(infinity) ? " " + temp : temp), 491, 412);
            temp = Integer.toString(weaponPackage.getWeaponDelay(1, 7));
            getImage().drawString((temp.length() == 1 ? " " + temp : temp), 564, 412);
            
            temp = (weaponPackage.getWeaponNumber(1, 8) == 11 ? infinity : Integer.toString(weaponPackage.getWeaponNumber(1, 8)));
            getImage().drawString((temp.length() == 1 && !temp.equals(infinity) ? " " + temp : temp), 706, 412);
            temp = Integer.toString(weaponPackage.getWeaponDelay(1, 8));
            getImage().drawString((temp.length() == 1 ? " " + temp : temp), 779, 412);
            
            temp = (weaponPackage.getWeaponNumber(1, 9) == 11 ? infinity : Integer.toString(weaponPackage.getWeaponNumber(1, 9)));
            getImage().drawString((temp.length() == 1 && !temp.equals(infinity) ? " " + temp : temp), 63, 575);
            temp = Integer.toString(weaponPackage.getWeaponDelay(1, 9));
            getImage().drawString((temp.length() == 1 ? " " + temp : temp), 135, 575);
            
            temp = (weaponPackage.getWeaponNumber(1, 10) == 11 ? infinity : Integer.toString(weaponPackage.getWeaponNumber(1, 10)));
            getImage().drawString((temp.length() == 1 && !temp.equals(infinity) ? " " + temp : temp), 278, 575);
            temp = Integer.toString(weaponPackage.getWeaponDelay(1, 10));
            getImage().drawString((temp.length() == 1 ? " " + temp : temp), 350, 575);
            
        }*/
    }
}
