import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Blowtorch here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Blowtorch extends Weapon
{
    private int burningCounter = 0;
    
    private boolean imageLeft = false;
    private boolean burning = false;
    
    private Worm worm;
    
    public Blowtorch(Worm worm) {
        this.worm = worm;
    }
    
    public void act() {
        if (getWorld().getObjects(Break_Menu.class).isEmpty()) {
            run();
        }
    }
    
    public void run() {
        FullScreenMouseInfo mouse = FullScreenWindow.getMouseInfo();
        if (mouse != null) {
            if (mouse.getX() < worm.getX()) {
                if (!imageLeft) {
                    getImage().mirrorVertically();
                    imageLeft = true;
                }
            }
            else {
                if (imageLeft) {
                    getImage().mirrorVertically();
                    imageLeft = false;
                }
            }
            double[] newCoordinates = move(worm.getX(), worm.getY(), direction(mouse.getX() - worm.getX(), mouse.getY() - worm.getY()), 30);
            setLocation((int) newCoordinates[0], (int) newCoordinates[1]);
            turnTo(worm.getX(), worm.getY());
            turn(180);
        }
        if (burning) {
            double[] burningCoordinates = move(getX(), getY(), getRotation(), 20);
            destroyWorld((int) burningCoordinates[0], (int) burningCoordinates[1], 20);
            if (imageLeft) {
                worm.moveLeft();
            }
            else {
                worm.moveRight();
            }
            burningCounter++;
            if (burningCounter >= 200) {
                getWorld().removeObject(this);
            }
        }
        else if (FullScreenWindow.mouseClicked(null)) {
            burning = true;
        }
    }
}
