import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Break_Menu here.
 * 
 * @author (your name)
 * @version (a version number or a date)
 */
public class Break_Menu extends Menu
{
    private int x;
    private int y;
    private int numberOfActs;
    
    public Break_Menu() {
        changeImage(new GreenfootImage("Break_Menu.jpg"));
    }
    
    public void act() {
        FullScreenMouseInfo mouse = FullScreenWindow.getMouseInfo();
        if (mouse != null) {
            x = mouse.getX();
            y = mouse.getY();
        }
        if (FullScreenWindow.mouseClicked(null)) {
            if (x > 480 && x < 730) {
                if (y > 210 && y < 260) {
                    //resume game;
                    ((Worms_Land) getWorld()).startClock();
                    try {
                        ((Worms_Land) getWorld()).getExecutingWorm().getClock().startClock();
                    }
                    catch (NullPointerException npe) {
                        //npe.printStackTrace();
                    }
                    ((Worms_Land) getWorld()).resetPausingCounter();
                    try {
                        getWorld().removeObject(this);
                    }
                    catch (NullPointerException npe) {
                        //npe.printStackTrace();
                    }
                }
                else if (y > 325 && y < 375) {
                    //restart game;
                    ((Worms_Land) getWorld()).startGame();
                    try {
                        getWorld().removeObject(this);
                    }
                    catch (NullPointerException npe) {
                        //npe.printStackTrace();
                    }
                }
                else if (y > 445 && y < 495) {
                    //main menu;
                    //((Worms_Land) getWorld()).stopMusic();
                    ((Worms_Land) getWorld()).removeAllObjectsBut(this);
                    getWorld().addObject(new Main_Menu(), 600, 350);
                    try {
                        getWorld().removeObject(this);
                    }
                    catch (NullPointerException npe) {
                        //npe.printStackTrace();
                    }
                }
            }
        }
        if (numberOfActs >= 10) {
            if (FullScreenWindow.isKeyDown(Settings.wormPause)) {
                ((Worms_Land) getWorld()).startClock();
                ((Worms_Land) getWorld()).resetPausingCounter();
                try {
                    getWorld().removeObject(this);
                }
                catch (NullPointerException npe) {
                    //npe.printStackTrace();
                }
            }
        }
        else {
            numberOfActs++;
        }
    }
}
