import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.awt.Font;

/**
 * Write a description of class Profile_Menu here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Profile_Menu extends Menu
{
    private int x;
    private int y;
    
    private int activeTextField = 1;
    private int cursorVisibleCounter = 0;
    
    private String input = "";
    
    private String names[] = {"", "", "", "", "", ""};
    
    public Profile_Menu() {
        changeImage(new GreenfootImage("Profile_Menu.png"));
    }
    
    public void act() {
        if (getWorld().getObjects(Break_Menu.class).isEmpty()) {
            run();
        }
    }
    
    public void run() {
        FullScreenMouseInfo mouse = FullScreenWindow.getMouseInfo();
        if (mouse != null) {
            x = mouse.getX();
            y = mouse.getY();
        }
        if (FullScreenWindow.mouseClicked(null)) {
            if (x > 15 && x < 390 && y > 135 && y < 185) {
                activeTextField = 1;
            }
            if (x > 815 && x < 1185 && y > 135 && y < 185) {
                activeTextField = 2;
            }
            if (x > 415 && x < 790 && y > 195 && y < 250) {
                activeTextField = 3;
            }
            if (x > 415 && x < 790 && y > 300 && y < 355) {
                activeTextField = 4;
            }
            if (x > 415 && x < 790 && y > 410 && y < 460) {
                activeTextField = 5;
            }
            if (x > 415 && x < 790 && y > 515 && y < 570) {
                activeTextField = 6;
            }
            if (y > 625 && y < 680) {
                if (x > 340 && x < 590) {
                    //Back;
                    getWorld().removeObject(this); 
                    return;
                } 
                if (x > 625 && x < 875) {
                    //Finished;
                    if (!names[0].equals("") && !names[1].equals("") && !names[2].equals("") && !names[3].equals("") && !names[4].equals("") && !names[5].equals("")) {
                        Profile profile = new Profile(names);
                        profile.saveProfile();
                        getWorld().removeObject(this);
                        return;
                    }
                    else {
                        //add dialog menu;
                    }
                } 
            }
        }
        input = FullScreenWindow.getKey();
        if (input == "backspace" && names[activeTextField-1].length() != 0) {
            names[activeTextField-1] = names[activeTextField-1].substring(0, names[activeTextField-1].length()-1);
        }
        else if (input == "enter") {
            activeTextField++;
            if (activeTextField == 7) {
                activeTextField = 1;
            }
        }
        else if (input != null && input.length() > 1) {
            input = "";
        }
        else if (input != null) {
            names[activeTextField-1] = names[activeTextField-1] + input;
        }
        if (names[activeTextField-1].length() > 15) {
            names[activeTextField-1] = names[activeTextField-1].substring(0, 15);
        }
        drawNumbers();
    }    
    
    private void drawNumbers() {
        int lineX = 0;
        int lineY = 0;
        GreenfootImage img = new GreenfootImage(names[activeTextField-1], 35, Color.black, Color.black);
        cursorVisibleCounter++;
        if (cursorVisibleCounter > 80) {
            cursorVisibleCounter = 0;
        }
        switch (activeTextField) {
            case 1:
                lineX = 25;
                lineY = 140;
                break;
            case 2:
                lineX = 826;
                lineY = 140;
                break;
            case 3:
                lineX = 425;
                lineY = 200;
                break;
            case 4:
                lineX = 425;
                lineY = 308;
                break;
            case 5:
                lineX = 425;
                lineY = 413;
                break;
            case 6:
                lineX = 425;
                lineY = 520;
                break;
        }
        //overwrite the old numbers/text;
        getImage().setColor(getImage().getColorAt(18, 137));
        getImage().fillRect(19, 139, 365, 41);
        getImage().fillRect(820, 139, 365, 41);
        getImage().fillRect(419, 199, 365, 43);
        getImage().fillRect(419, 307, 365, 43);
        getImage().fillRect(419, 411, 365, 43);
        getImage().fillRect(419, 519, 365, 43);
        //write the new text;
        getImage().drawImage(new GreenfootImage(names[0], 35, Color.white, new Color(0, 0, 0, 0)), 25, 140);
        getImage().drawImage(new GreenfootImage(names[1], 35, Color.white, new Color(0, 0, 0, 0)), 826, 140);
        getImage().drawImage(new GreenfootImage(names[2], 35, Color.white, new Color(0, 0, 0, 0)), 425, 200);
        getImage().drawImage(new GreenfootImage(names[3], 35, Color.white, new Color(0, 0, 0, 0)), 425, 308);
        getImage().drawImage(new GreenfootImage(names[4], 35, Color.white, new Color(0, 0, 0, 0)), 425, 413);
        getImage().drawImage(new GreenfootImage(names[5], 35, Color.white, new Color(0, 0, 0, 0)), 425, 520);
        getImage().setColor(Color.white);
        if (cursorVisibleCounter > 40) {
            getImage().fillRect((int) (lineX + img.getWidth() + 2), lineY + 3, 3, img.getHeight());
        }
    }
}
