import greenfoot.*;
public class Water implements Material
{
    private static GreenfootImage Image = CreateMaterialImage();
    
    private static GreenfootImage CreateMaterialImage()
    {
        GreenfootImage i = new GreenfootImage(1,1);
        i.setColor(new java.awt.Color(0,0,255,100));
        i.fill();
        return i;
    }
    
    public GreenfootImage getMaterialImage()
    {
        return Image;
    }
    
    public boolean isLiquid()
    {
        return true;
    }

    public double resistance()
    {
        return 0.03;
    }
    
    public boolean canFall()
    {
        return false;
    }

    public boolean isAir()
    {
        return false;
    }
    
    public int getMaterial()
    {
        return 3;
    }
}
