/**
 * Write a description of class Game_Settings here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Weapon_Package implements Cloneable
{
    private int[][] startingWeapons;
    
    private Party party_1;
    private Party party_2;
    private Party party_3;
    private Party party_4;
    
    public Weapon_Package(int[][] weapons) {
        startingWeapons = weapons;
        switch (Settings.partys) {
            case 2:
                party_1 = new Party(weapons);
                party_2 = new Party(weapons);
                break;
            case 3:
                party_1 = new Party(weapons);
                party_2 = new Party(weapons);
                party_3 = new Party(weapons);
                break;
            case 4:
                party_1 = new Party(weapons);
                party_2 = new Party(weapons);
                party_3 = new Party(weapons);
                party_4 = new Party(weapons);
                break;
        }
    }
    
    public Weapon_Package(Weapon_Package weaponPackage) {//copy constructor
        this.startingWeapons = weaponPackage.getStartingWeapons();
        switch (Settings.partys) {
            case 2:
                party_1 = new Party(startingWeapons);
                party_2 = new Party(startingWeapons);
                break;
            case 3:
                party_1 = new Party(startingWeapons);
                party_2 = new Party(startingWeapons);
                party_3 = new Party(startingWeapons);
                break;
            case 4:
                party_1 = new Party(startingWeapons);
                party_2 = new Party(startingWeapons);
                party_3 = new Party(startingWeapons);
                party_4 = new Party(startingWeapons);
                break;
        }
    }
    
    public Party getParty(int number) {
        switch (number) {
            case 1:
                return party_1;
            case 2:
                return party_2;
            case 3:
                return party_3;
            case 4:
                return party_4;
            default:
                return null;
        }
    }
    
    public int[][] getStartingWeapons() {
        return startingWeapons;
    }
    
    public int[] getWeaponNumber(int party) {
        int[] weaponNumber = new int[10];
        for (int i = 0; i < 10; i++) {
            weaponNumber[i] = getWeaponNumber(party, i+1);
        }
        return weaponNumber;
    }
    
    public boolean[] getWeaponUsability(int party) {
        boolean[] weaponUsability = new boolean[10];
        for (int i = 0; i < 10; i++) {
            if (getWeaponNumber(party, i+1) > 0 && getWeaponDelay(party, i+1) <= 0) {
                weaponUsability[i] = true;
            }
            else {
                weaponUsability[i] = false;
            }
        }
        return weaponUsability;
    }
    
    public int getWeaponNumber(int party, int weapon) {
        return getParty(party).getWeaponNumber(weapon);
    }
    public void setWeaponNumber(int party, int weapon, int change) {
        getParty(party).setWeaponNumber(weapon, change);
    }
    
    public int getWeaponDelay(int party, int weapon) {
        return getParty(party).getWeaponDelay(weapon);
    }
    public void setWeaponDelay(int party, int weapon, int change) {
        getParty(party).setWeaponDelay(weapon, change);
    }
    public void decrementWeaponDelay(int party) {
        for (int i = 0; i < 10; i++) {
            getParty(party).setWeaponDelay(i+1, -1);
        }
    }
}
