import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.awt.Font;

/**
 * Write a description of class Wind here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class WindDisplay extends Actor
{
    
    public WindDisplay() {
        GreenfootImage img = getImage();
        img.clear();
        img.scale(160, 90);
        img.setColor(Color.gray);
        img.fill();
        img.setColor(Color.red);
        img.setFont(new Font("font_20", Font.BOLD, 20));
        img.drawString("Wind:", 55, 25);
    }
    
    public void redrawImage() {
        GreenfootImage img = getImage();
        GreenfootImage windArrow = new GreenfootImage("Wind_Arrow.jpg");
        img.setColor(Color.gray);
        img.fill();
        img.setColor(Color.black);
        img.setFont(new Font("font_20", Font.BOLD, 20));
        img.drawString("Wind:", 55, 25);
        if (Worms_Land.WIND > 0.04) {
            img.drawImage(windArrow, 25, 45);
            img.drawImage(windArrow, 55, 45);
            img.drawImage(windArrow, 85, 45);
            img.drawImage(windArrow, 115, 45);
        }
        else if (Worms_Land.WIND > 0.03) {
            img.drawImage(windArrow, 25, 45);
            img.drawImage(windArrow, 55, 45);
            img.drawImage(windArrow, 85, 45);
        }
        else if (Worms_Land.WIND > 0.02) {
            img.drawImage(windArrow, 25, 45);
            img.drawImage(windArrow, 55, 45);
        }
        else if (Worms_Land.WIND > 0.01) {
            img.drawImage(windArrow, 25, 45);
        }
        else if (Worms_Land.WIND <= 0.01 && Worms_Land.WIND >= - 0.01) {
            //no wind;
        }
        else if (Worms_Land.WIND > -0.02) {
            windArrow.mirrorHorizontally();
            img.drawImage(windArrow, 115, 45);
        }
        else if (Worms_Land.WIND > -0.03) {
            windArrow.mirrorHorizontally();
            img.drawImage(windArrow, 85, 45);
            img.drawImage(windArrow, 115, 45);
        }
        else if (Worms_Land.WIND > -0.04) {
            windArrow.mirrorHorizontally();
            img.drawImage(windArrow, 55, 45);
            img.drawImage(windArrow, 85, 45);
            img.drawImage(windArrow, 115, 45);
        }
        else {
            windArrow.mirrorHorizontally();
            img.drawImage(windArrow, 25, 45);
            img.drawImage(windArrow, 55, 45);
            img.drawImage(windArrow, 85, 45);
            img.drawImage(windArrow, 115, 45);
        }
    }
}
